#define NOMINMAX
#include <windows.h>
#include <shlwapi.h>
#include <stdio.h>
#include <string>
#include <sstream>
#include "filter.h"

#include "animEffect_func.h"

#pragma comment(lib,"shlwapi.lib")

#define AUFNAME "`GtFNg"
#define lengthof(arr) (sizeof(arr)/sizeof((arr)[0]))

static char g_dllpath[4096];

//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
static TCHAR	*track_name[] =		{"[h","LineStep","oԊu","Length","Width","Noise","VFlag", "Zx", "݇", "X", "Zx", "XVԊu","","Xϓ","Xϓ","Yϓ","g嗦","]px","ʓxW","xW","CannyTh1","CannyTh2"};
static int		track_default[] =	{1,   5,  54,     0,   1,   15,     0, 100,   0, -100, 100,   1,     0, 100,  175,  175,  100,    0,  100,  200, 2000, 3000};
static int		track_s[] =         {1,   1,   1, -1000,   0,    0,   -20,   0,   0, -500,   0,   0,     0,   0,    0,    0,    1, -360,    0,    0,    0,    0};
static int		track_e[] =         {5, 100, 100,  1000, 100, 1000,     9, 200,  10,  500, 100, 100, 65536, 200, 1000, 1000, 1000,  360, 5000, 5000,10000,10000};


static TCHAR *check_name[] = {"C","Canny","nb`O","gU","nb`Op^[]","nb`OԂ(޲Ʊ)","nb`OԂ(޲ޯ)","}XN쐬"};
static int check_default[] = {1,0,1,0,0,0,0,0};

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION|FILTER_FLAG_MAIN_MESSAGE,	// int flag
	NULL,NULL,	// int x,y
	AUFNAME,	// TCHAR *name
	lengthof(track_name),track_name,track_default,	// int track_n, TCHAR **track_name, int *track_default
	track_s,track_e,	// int *track_s, *track_e
	lengthof(check_name),check_name,check_default,	// int check_n, TCHAR **check_name, int *check_default
	func_proc,	// (*func_proc)
	NULL,	// (*func_init)
	func_exit,	// (*func_exit)
	func_update,	// (*func_update)
	func_WndProc,	// (*func_WndProc)
	NULL,NULL,	// reserved
	NULL,	// void *ex_data_ptr
	NULL,	// int ex_data_size
	AUFNAME" Ver0.04",	// TCHAR *information
	NULL,	// (*func_save_start)
	NULL,	// (*func_save_end)
};

//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	InitAnimEffect(g_dllpath, &filter);
	return &filter;
}

//---------------------------------------------------------------------
//		func_exit
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp ) {
	ExitAnimEffect();
	return TRUE;
}

//---------------------------------------------------------------------
//		func_proc
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	DWORD tick = GetTickCount();

	if (ExecAnimEffect(fp, fpip) != TRUE) {
		return FALSE;
	}

	tick = GetTickCount() - tick;

	if(!fp->exfunc->is_saving(fpip->editp)){
		char str[255];
		sprintf_s(str, sizeof(str), AUFNAME" time:%d", tick);
		SetWindowText(fp->hwnd, str);
	}


	return TRUE;
}

//---------------------------------------------------------------------
//		func_update
//---------------------------------------------------------------------
BOOL func_update( FILTER *fp,int status )
{
	//UpdateAnimEffect(fp);
	return TRUE;
}

//---------------------------------------------------------------------
//		WndProc
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam,void *editp,FILTER *fp )
{
	return FALSE;
}


#pragma warning(disable:4996)
BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	char dllpath[4096];
	char *envpath;
	std::stringstream newpath("");

	switch (fdwReason) {
    case DLL_PROCESS_ATTACH:
		memset(dllpath, 0x00, sizeof(dllpath));
		GetModuleFileName(hinstDLL, dllpath, sizeof(dllpath)-1);
		PathRemoveFileSpec(dllpath);
		strcpy(g_dllpath, dllpath);

		envpath = getenv("PATH");
		newpath << "PATH=" << envpath << ";" << dllpath;
		putenv(newpath.str().c_str());
        break;

    case DLL_PROCESS_DETACH:
        break;

    case DLL_THREAD_ATTACH:
        break;

    case DLL_THREAD_DETACH:
        break;
    }
    return  TRUE;
}

